#include "robot.h"
#include <stdbool.h>
#include <stdlib.h>

#define width 8
#define height 7
static unsigned char field[height][width];

void initialize(void)
{
  for(int i = 0; i < height; i++)
  {
    for(int j = 0; j < width; j++)
    {
      field[i][j] = (unsigned char)(rand()%4);
    }
  }
}

static int x = 0;
static int y = 0;
static int inventory = 0;

bool execute(Command c)
{
  switch(c.op)
  {
  case left:
    x -= c.count;
    if(x < 0)
    {
      x = 0;
      return false;
    }
    break;
  case right:
    x += c.count;
    if(x >= width)
    {
      x = width-1;
      return false;
    }    
    break;
  case up:
    y -= c.count;
    if(y < 0)
    {
      y = 0;
      return false;
    }
    break;      
  case down:
    y += c.count;
    if(y >= height)
    {
      y = height-1;
      return false;
    }    
    break;
  case fetch:
    {
      int z = field[y][x];
      z -= c.count;
      bool err = false;
      if(z < 0)
      {
        z = 0;
        err = true;
      }
      inventory += field[y][x] - z;
      field[y][x] = z;
      if(err)
      {
        return false;
      }
    }
    break;
  case put:
    
    // TODO
    
    
    break;
  default:
    return false;
  }
  
  
  return true;
}